"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BabelMain = void 0;
function _cli() {
  const data = require("@teambit/cli");
  _cli = function () {
    return data;
  };
  return data;
}
function _compiler() {
  const data = require("@teambit/compiler");
  _compiler = function () {
    return data;
  };
  return data;
}
function _logger() {
  const data = require("@teambit/logger");
  _logger = function () {
    return data;
  };
  return data;
}
function _compilation() {
  const data = require("@teambit/compilation.babel-compiler");
  _compilation = function () {
    return data;
  };
  return data;
}
function babel() {
  const data = _interopRequireWildcard(require("@babel/core"));
  babel = function () {
    return data;
  };
  return data;
}
function _babel() {
  const data = require("./babel.aspect");
  _babel = function () {
    return data;
  };
  return data;
}
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
class BabelMain {
  constructor(logger, compiler) {
    this.logger = logger;
    this.compiler = compiler;
  }
  createCompiler(options, babelModule = babel()) {
    return new (_compilation().BabelCompiler)(_babel().BabelAspect.id, this.logger, options, options.babelTransformOptions || {}, babelModule);
  }
  getPackageJsonProps() {
    return {
      main: 'dist/{main}.js'
    };
  }
  static async provider([loggerExt, compiler]) {
    const logger = loggerExt.createLogger(_babel().BabelAspect.id);
    return new BabelMain(logger, compiler);
  }
}
exports.BabelMain = BabelMain;
_defineProperty(BabelMain, "runtime", _cli().MainRuntime);
_defineProperty(BabelMain, "dependencies", [_logger().LoggerAspect, _compiler().CompilerAspect]);
_babel().BabelAspect.addRuntime(BabelMain);

//# sourceMappingURL=babel.main.runtime.js.map